/* 
* -cr_beg-
* ********************************************************************
* IBM Confidential
* OCO Source Materials
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
* Copyright IBM Corp. 2013
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
* ********************************************************************
* -cr_end-
*/ 
#include "ioqdb2data.h"
#include "ioqdb2udfinclude.h"

#ifndef __OPTIMMASK_DB2_FUNC__
#define __OPTIMMASK_DB2_FUNC__

#if defined(_CPLUSPLUS) || defined(__ZOSCPP__)
extern "C"
{
#endif
//---------------------------------------------------------------------------
// Function:   OptimMaskStr
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStr(
//Arg1 CLOB(800),
//ParamString CLOB(800) ) 
//returns varchar(800) cast from CLOB(800)
//specific sOptimMaskStr
//external name '<UDF library path>!OptimMaskStr'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStr(   SQLUDF_CLOB          *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_CLOB          *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskStrUTF16
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStrUTF16(
//Arg1 DBCLOB(800),
//ParamString DBCLOB(800) ) 
//returns vargraphic(800) cast from DBCLOB(800)
//specific sOptimMaskStrUtf16
//external name '<UDF library path>!OptimMaskStrUtf16'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
void OptimMaskStrUtf16(   
                     SQLUDF_DBCLOB        *pArg1,
                     SQLUDF_DBCLOB        *pParamString, 
                     SQLUDF_DBCLOB        *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//********* I M P O R T A N T **************************
//This is a exception from the standard syntax of DB2 UDF's 
//which accept a CLOB for input date/time.
//The Date/Time in DB2 is passed as a CHAR string to the UDF 
//and is not castable to CLOB so we use a VARCHAR both for 
//INPUT date/time as well as return value.
//********* I M P O R T A N T **************************
//---------------------------------------------------------------------------
// Function:   OptimMaskDate
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskDate(
//Arg1 DATE,
//ParamString CLOB(800) ) 
//returns DATE
//specific sOptimMaskDate
//external name '<UDF library path>!OptimMaskDate'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 100
//final call
//dbinfo
//allow parallel
void OptimMaskDate(  SQLUDF_VARCHAR       *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_VARCHAR       *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//********* I M P O R T A N T **************************
//This is a exception from the standard syntax of DB2 UDF's 
//which accept a CLOB for input date/time.
//The Date/Time in DB2 is passed as a CHAR string to the UDF 
//and is not castable to CLOB so we use a VARCHAR both for 
//INPUT date/time as well as return value.
//
//---------------------------------------------------------------------------
// Function:   OptimMaskTS
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//REGISTRATION:
//Create  or replace function OptimMaskTimeStamp(
//Arg1 TIMESTAMP,
//ParamString CLOB(800) ) 
//returns TIMESTAMP
//specific sOptimMaskTS
//external name '<UDF library path>!OptimMaskTS'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 100
//final call
//dbinfo
//allow parallel
void OptimMaskTS(    SQLUDF_VARCHAR       *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_VARCHAR       *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskInt64
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//REGISTRATION:
//Create  or replace function OptimMaskInt64(
//Arg1 BIGINT,
//ParamString CLOB(800) ) 
//returns BIGINT
//specific sOptimMaskInt64
//external name '<UDF library path>!OptimMaskInt64'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
void OptimMaskInt64( SQLUDF_BIGINT        *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_BIGINT        *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskInt32
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//REGISTRATION:
//Create  or replace function OptimMaskInt32(
//Arg1 INT,
//ParamString CLOB(800) ) 
//returns INT
//specific sOptimMaskInt32
//external name '<UDF library path>!OptimMaskInt32'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
void OptimMaskInt32( SQLUDF_INTEGER       *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_INTEGER       *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskInt16
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//REGISTRATION:
//Create  or replace function OptimMaskInt32(
//Arg1 SMALLINT,
//ParamString CLOB(800) ) 
//returns SMALLINT
//specific sOptimMaskInt16
//external name '<UDF library path>!OptimMaskInt16'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
void OptimMaskInt16( SQLUDF_SMALLINT      *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_SMALLINT      *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskDouble
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//REGISTRATION:
//Create  or replace function OptimMaskDouble(
//Arg1 DOUBLE
//ParamString CLOB(800) ) 
//returns DOUBLE
//specific sOptimMaskDouble
//external name '<UDF library path>!OptimMaskDouble'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
void OptimMaskDouble(SQLUDF_DOUBLE        *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_DOUBLE        *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr2
//
//    Desc:    Accepts 2 CLOB data argument and a parameter string
//             returns a varchar
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStr2(
//Arg1 CLOB(800),
//Arg2 CLOB(800),
//ParamString CLOB(800) ) 
//returns varchar(800) cast from CLOB(800)
//specific sOptimMaskStr2
//external name '<UDF library path>!OptimMaskStr2'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStr2(  SQLUDF_CLOB          *pArg1,
                     SQLUDF_CLOB          *pArg2,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_CLOB          *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pArg2Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);


//---------------------------------------------------------------------------
// Function:   OptimMaskStr3
//
//    Desc:    Accepts 3 CLOB data argument and a parameter string
//             returns a varchar
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStr3(
//Arg1 CLOB(800),
//Arg2 CLOB(800),
//Arg3 CLOB(800),
//ParamString CLOB(800) ) 
//returns varchar(800) cast from CLOB(800)
//specific sOptimMaskStr3
//external name '<UDF library path>!OptimMaskStr3'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStr3(  SQLUDF_CLOB          *pArg1,
                     SQLUDF_CLOB          *pArg2,
                     SQLUDF_CLOB          *pArg3,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_CLOB          *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pArg2Ind,
                     SQLUDF_NULLIND       *pArg3Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr4
//
//    Desc:    Accepts 4 CLOB data argument and a parameter string
//             returns a varchar
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStr4(
//Arg1 CLOB(800),
//Arg2 CLOB(800),
//Arg3 CLOB(800),
//Arg4 CLOB(800),
//ParamString CLOB(800) ) 
//returns varchar(800) cast from CLOB(800)
//specific sOptimMaskStr4
//external name '<UDF library path>!OptimMaskStr4'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStr4(  SQLUDF_CLOB          *pArg1,
                     SQLUDF_CLOB          *pArg2,
                     SQLUDF_CLOB          *pArg3,
                     SQLUDF_CLOB          *pArg4,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_CLOB          *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pArg2Ind,
                     SQLUDF_NULLIND       *pArg3Ind,
                     SQLUDF_NULLIND       *pArg4Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr5
//
//    Desc:    Accepts 5 CLOB data argument and a parameter string
//             returns a varchar
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStr5(
//Arg1 CLOB(800),
//Arg2 CLOB(800),
//Arg3 CLOB(800),
//Arg4 CLOB(800),
//Arg5 CLOB(800),
//ParamString CLOB(800) ) 
//returns varchar(800) cast from CLOB(800)
//specific sOptimMaskStr5
//external name '<UDF library path>!OptimMaskStr5'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStr5(  SQLUDF_CLOB          *pArg1,
                     SQLUDF_CLOB          *pArg2,
                     SQLUDF_CLOB          *pArg3,
                     SQLUDF_CLOB          *pArg4,
                     SQLUDF_CLOB          *pArg5,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_CLOB          *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pArg2Ind,
                     SQLUDF_NULLIND       *pArg3Ind,
                     SQLUDF_NULLIND       *pArg4Ind,
                     SQLUDF_NULLIND       *pArg5Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr6
//
//    Desc:    Accepts 6 CLOB data argument and a parameter string
//             returns a varchar
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStr6(
//Arg1 CLOB(800),
//Arg2 CLOB(800),
//Arg3 CLOB(800),
//Arg4 CLOB(800),
//Arg5 CLOB(800),
//Arg6 CLOB(800),
//ParamString CLOB(800) ) 
//returns varchar(800) cast from CLOB(800)
//specific sOptimMaskStr6
//external name '<UDF library path>!OptimMaskStr6'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStr6(  SQLUDF_CLOB          *pArg1,
                     SQLUDF_CLOB          *pArg2,
                     SQLUDF_CLOB          *pArg3,
                     SQLUDF_CLOB          *pArg4,
                     SQLUDF_CLOB          *pArg5,
                     SQLUDF_CLOB          *pArg6,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_CLOB          *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pArg2Ind,
                     SQLUDF_NULLIND       *pArg3Ind,
                     SQLUDF_NULLIND       *pArg4Ind,
                     SQLUDF_NULLIND       *pArg5Ind,
                     SQLUDF_NULLIND       *pArg6Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskStrInt
//
//    Desc:    Accepts 1 CLOB data argument and a parameter string
//             returns a integer
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStrInt(
//Arg1 CLOB(800),
//ParamString CLOB(800) ) 
//returns INTEGER
//specific sOptimMaskStrInt
//external name '<UDF library path>!OptimMaskStrInt'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStrInt(SQLUDF_CLOB          *pArg1,
                     SQLUDF_CLOB          *pParamString, 
                     SQLUDF_INTEGER       *pRet,
                     SQLUDF_NULLIND       *pArg1Ind,
                     SQLUDF_NULLIND       *pPSInd,
                     SQLUDF_NULLIND       *pRetInd,
                     SQLUDF_CHAR          *pSqlstate,
                     SQLUDF_CHAR          *pFname,
                     SQLUDF_CHAR          *pFspecname,
                     SQLUDF_CHAR          *pMsgtext,
                     SQLUDF_SCRATCHPAD    *pScratchpad,
                     SQLUDF_CALL_TYPE     *pCallType,
                     SQLUDF_DBINFO        *pDbInfo);

//---------------------------------------------------------------------------
// Function:   OptimMaskStr2Int
//
//    Desc:    Accepts 2 CLOB data argument and a parameter string
//             returns a integer
//
//-------------------------------------------------------------------------
//   Registration command for this function
//-------------------------------------------------------------------------
//Create  or replace function OptimMaskStr2Int(
//Arg1 CLOB(800),
//Arg2 CLOB(800),
//ParamString CLOB(800) ) 
//returns INTEGER
//specific sOptimMaskStr2Int
//external name '<UDF library path>!OptimMaskStr2Int'
//Language C
//parameter style SQL
//not deterministic
//fenced threadsafe
//called on null input
//no sql
//external action
//scratchpad 10
//final call
//dbinfo
//allow parallel
//-------------------------------------------------------------------------
void OptimMaskStr2Int(  SQLUDF_CLOB          *pArg1,
                        SQLUDF_CLOB          *pArg2,
                        SQLUDF_CLOB          *pParamString, 
                        SQLUDF_INTEGER       *pRet,
                        SQLUDF_NULLIND       *pArg1Ind,
                        SQLUDF_NULLIND       *pArg2Ind,
                        SQLUDF_NULLIND       *pPSInd,
                        SQLUDF_NULLIND       *pRetInd,
                        SQLUDF_CHAR          *pSqlstate,
                        SQLUDF_CHAR          *pFname,
                        SQLUDF_CHAR          *pFspecname,
                        SQLUDF_CHAR          *pMsgtext,
                        SQLUDF_SCRATCHPAD    *pScratchpad,
                        SQLUDF_CALL_TYPE     *pCallType,
                        SQLUDF_DBINFO        *pDbInfo);

#if defined(_CPLUSPLUS) || defined(__ZOSCPP__)
}
#endif

#endif //__OPTIMMASK_DB2_FUNC__
